/*
 *  COMMANDS, {akii-root}/src/commands.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#ifdef _AIX
#include <sys/select.h>
#endif
#include "error.h"
#include "commands.h"
#include "variables.h"
#include "regexp.h"
#include "expression.h"
#include "interpreter.h"
#include "netread.h"
#include "screen.h"
#include "main.h"
#include "debug.h"
#include "terms.h"

int flag = 0;
int purge = 0;
int purge_mod = 0;
char *toretlenargs = NULL;

struct filelist *flist = NULL;

struct renlist {
    int i;
    struct valtozo *var;
    struct renlist *next, *prev;
};
char *callfv(struct valtozo *fv, char *args)
{
    char **numvarlist_save = numvarlist;
    char *toretlenargs_save = toretlenargs;
    struct valtozo *var;
    struct valtozo *lvar, *svar;
    char *s;
    struct aliasstr *ali;
    REXELEM szok =
    {0, NULL};
    char **szavak = NULL;
    char temp[500], *t = temp;
    int i;
    int save_varflag;

#ifdef AKII_DEBUG
    dbgenter(dbg_callfv, fv->nev);
#endif
    strcpy(temp, "akii.RETURN");
    varflag = VFLAG_BELSO;
    var = getvar(&bivarlist, &t, 1, 0);
    varflag = save_varflag;
    setvar(var, "");
    i = regqszavak(args, &szok);
    if (i) {
	szavak = malloc(sizeof(char *) * (i + 1));

	szavak[0] = (char *) i;
	for (; i; i--)
	    szavak[i] = szok.s[i - 1];
	free(szok.s);
	numvarlist = szavak;
    }
    else {
	numvarlist = malloc(sizeof(char *));

	numvarlist[0] = (char *) 0;
    }
    toretlenargs = args;

    if (fv->tipus == VAR_FV) {
	((void (*)()) fv->ertek) (var);
	if (flag) {
	    if (errno == EKEVESARG) {
		sprintf(errtemp, "%s: %s parameter szukseges", fv->nev, errtemp + 1000);
	    }
	    else if (errno) {
		sprintf(errtemp, "%s: %s", fv->nev, errtemp + 600);
	    }
	}
    }
    else {
	locallevel++;
	ali = (struct aliasstr *) (fv->ertek);
	if (!numvarlist)
	    i = 0;
	else
	    i = (int) numvarlist[0];
	if (i < ali->cpnum) {
	    errno = EKEVESARG;
	    sprintf(errtemp, "%s: %d parameter szukseges", fv->nev, ali->cpnum);
	}
	else {
	    if (ali->cpnum) {
		for (i = 0; i < ali->cpnum; i++) {
		    s = ali->cps[i];
		    varflag = VFLAG_LOCAL;
		    lvar = getvar(&localvars[locallevel], &s, 1, 0);
		    varflag = save_varflag;
		    if (errno) {
			flag = 0;
			freenumvarlist(&numvarlist);	/* &szavak */
			numvarlist = numvarlist_save;
			toretlenargs = toretlenargs_save;
			freevarlist(localvars[locallevel--], 1);
#ifdef AKII_DEBUG
			dbgleave(dbg_callfv);
#endif
			return (var->ertek);
		    }
		    s = numvarlist[i + 1];
		    svar = getvar(&bivarlist, &s, 0, 1);
		    if ((errno == ENOVAR) || (errno == ENOSTRUCTELEM)) {
			svar = varlist;
			s = numvarlist[i + 1];
			varflag = VFLAG_NORMAL;
			svar = getvar(&svar, &s, 1, 1);
			varflag = save_varflag;
		    }
		    if (errno) {
			flag = 0;
			freenumvarlist(&numvarlist);	/* &szavak */
			numvarlist = numvarlist_save;
			toretlenargs = toretlenargs_save;
			freevarlist(localvars[locallevel--], 1);
#ifdef AKII_DEBUG
			dbgleave(dbg_callfv);
#endif
			return (var->ertek);
		    }
		    lvar->tipus = VAR_FOREACH;
		    free(lvar->ertek);
		    lvar->ertek = (char *) svar;
		}
	    }
	    doparancssor(ali->par);
	    freevarlist(localvars[locallevel--], 1);
	}
    }
    flag = 0;
    freenumvarlist(&numvarlist);	/* &szavak */
    numvarlist = numvarlist_save;
    toretlenargs = toretlenargs_save;
#ifdef AKII_DEBUG
    dbgleave(dbg_callfv);
#endif
    return (var->ertek);
}

int parerror(int h)
{
    errno = 0;
    errtemp[0] = 0;
    if (!numvarlist) {
	errno = EKEVESARG;
	sprintf(errtemp + 1000, "%d", h);
	flag = 1;
	return (errno);
    }
    if ((int) numvarlist[0] < h) {
	errno = EKEVESARG;
	sprintf(errtemp + 1000, "%d", h);
	flag = 1;
    }
    return (errno);
}

void fv_getenv(struct valtozo *var)
{
    char *q;

    if (parerror(1))
	return;
    q = getenv(numvarlist[1]);
    if (!q)
	return;
    setvar(var, q);
    return;
}
void fv_left(struct valtozo *var)
{
    char *s;
    int mennyit;

    if (parerror(2))
	return;
    mennyit = strtol(numvarlist[1], &s, 10);
    if (*s) {
	errno = ENONUM;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    if ((mennyit < 0) || (mennyit > 250)) {
	errno = EEZSOK;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    s = getnumvar(numvarlist, 2, -1);
    if (strlen(s) <= mennyit)
	setvar(var, s);
    else {
	setnvar(var, s, mennyit);
    }
    free(s);
    return;
}
void fv_right(struct valtozo *var)
{
    char *s;
    int mennyit, i;

    if (parerror(2))
	return;
    mennyit = strtol(numvarlist[1], &s, 10);
    if (*s) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    if ((mennyit < 0) || (mennyit > 250)) {
	errno = EEZSOK;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    s = getnumvar(numvarlist, 2, -1);
    if ((i = strlen(s)) <= mennyit)
	setvar(var, s);
    else {
	setvar(var, s + (i - mennyit));
    }
    free(s);
    return;
}
void fv_mid(struct valtozo *var)
{
    char *s;
    int honnan, mennyit, i;

    if (parerror(3))
	return;
    honnan = strtol(numvarlist[1], &s, 10);
    if (*s) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    mennyit = strtol(numvarlist[2], &s, 10);
    if (*s) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    s = getnumvar(numvarlist, 3, -1);
    if ((mennyit < 1) || (mennyit > 2000) || honnan < 1) {
	errno = EEZSOK;
	flag = 1;
	strcpy(errtemp + 600, s);
	free(s);
	return;
    }
    i = strlen(s);
    if (i < honnan)
	return;
    if (i - honnan + 1 <= mennyit)
	setvar(var, s + (honnan - 1));
    else {
	setnvar(var, s + (honnan - 1), mennyit);
    }
    free(s);
    return;
}
void fv_index(struct valtozo *var)
{
    char *s, *p;
    int hol = 0;

    if (parerror(2))
	return;
    p = s = getnumvar(numvarlist, 2, -1);
    while (*p) {
	if (toupper(*p) == toupper(numvarlist[1][0]))
	    break;
	p++;
    }
    if (*p)
	hol = (p - s) + 1;
    setivar(var, hol);
    free(s);
    return;
}
void fv_rindex(struct valtozo *var)
{
    char *s, *p;
    int hol = 0;

    if (parerror(2))
	return;
    s = getnumvar(numvarlist, 2, -1);
    p = strrchr(s, numvarlist[1][0]);
    if (p)
	hol = (p - s) + 1;
    setivar(var, hol);
    free(s);
    return;
}
void toupp(char *s)
{
    while (*s) {
	*s = toupper(*s);
	s++;
    }
    return;
}
void fv_swordin(struct valtozo *var)
{
    int i, j;
    static char temp[10];

    if (parerror(2))
	return;
    i = (int) numvarlist[0];
    for (; i > 1; i--)
	if (istrcmp(numvarlist[i], numvarlist[1]) == 0)
	    break;
    sprintf(temp, "%d", i - 1);
    setvar(var, temp);
    return;
}
void fv_wordin(struct valtozo *var)
{
    char *s, *p, temp[10];

    if (parerror(2))
	return;
    s = getnumvar(numvarlist, 2, -1);
    toupp(s);
    toupp(numvarlist[1]);
    if (p = strstr(s, numvarlist[1])) {
	sprintf(temp, "%d", p - s + 1);
	setvar(var, temp);
    }
    else
	setvar(var, "0");
    free(s);
    return;
}
void fv_word(struct valtozo *var)
{
    int hanyadik;
    char *s;

    if (parerror(2))
	return;
    hanyadik = strtol(numvarlist[1], &s, 10);
    if (*s) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    if ((hanyadik < 1) || (hanyadik >= (int) numvarlist[0]))
	return;
    setvar(var, numvarlist[hanyadik + 1]);
    return;
}
void fv_time(struct valtozo *var)
{
    time_t ido;

    ido = time(NULL);
    setivar(var, ido);
    return;
}
void fv_stime(struct valtozo *var)
{
    time_t ido;
    char *s;

    if (parerror(1))
	return;
    ido = strtol(numvarlist[1], &s, 10);
    if (*s) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    if (ido < 0)
	return;
    setvar(var, ctime(&ido));
    var->ertek[strlen(var->ertek) - 1] = 0;
    return;
}
void fv_etime(struct valtozo *var)
{
    time_t ido, now;
    static char tmp[20];
    char *s;
    int ora, perc, sec;

    if (parerror(1))
	return;
    ido = strtol(numvarlist[1], &s, 10);
    if (*s) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    if (ido < 0)
	ido = 0;
    if ((int) numvarlist[0] >= 2) {
	now = strtol(numvarlist[2], &s, 10);
	if (*s) {
	    errno = ENONUM;
	    flag = 1;
	    strcpy(errtemp + 600, numvarlist[1]);
	    return;
	}
    }
    else
	now = time(NULL);
    if (now < ido)
	ido = 0;
    else
	ido = now - ido;
    sec = ido % 60;
    ido /= 60;
    perc = ido % 60;
    ora = ido / 60;
    sprintf(tmp, "%02d:%02d:%02d", ora, perc, sec);
    setvar(var, tmp);
    return;
}
void fv_match(struct valtozo *var)
{
    int i, j, hanyadik = 0;
    REXELEM r =
    {0, NULL};

    if (parerror(2))
	return;
    i = (int) numvarlist[0];
    freenumvarlist(&mchvarlist);
    mkerdojel = 0;
    for (j = 2; j <= i; j++) {
	if (regprobal(numvarlist[j], numvarlist[1], &r) >= 0) {
	    mkerdojel = j - 1;
	    hanyadik = j - 1;
	    mchvarlist = malloc(sizeof(char *) * (r.db + 1));

	    mchvarlist[0] = (char *) r.db;
	    for (; r.db; r.db--)
		mchvarlist[r.db] = r.s[r.db - 1];
	    free(r.s);
	    break;
	}
    }
    setivar(var, hanyadik);
    return;
}
void fv_rmatch(struct valtozo *var)
{
    int i, j, hanyadik = 0;
    REXELEM r =
    {0, NULL};

    if (parerror(2))
	return;
    i = (int) numvarlist[0];
    for (j = 2; j <= i; j++) {
	if (regprobal(numvarlist[1], numvarlist[j], NULL) >= 0) {
	    hanyadik = j - 1;
	    mkerdojel = hanyadik;
	    mchvarlist = malloc(sizeof(char *) * (r.db + 1));

	    mchvarlist[0] = (char *) r.db;
	    for (; r.db; r.db--)
		mchvarlist[r.db] = r.s[r.db - 1];
	    free(r.s);
	    break;
	}
    }
    setivar(var, hanyadik);
    return;
}
void toupper_tolower(struct valtozo *var, int up_or_low)
{
    char *s;
    int i = 0;

    if (parerror(1))
	return;
    s = getnumvar(numvarlist, 1, -1);
    setvar(var, s);
    free(s);
    while (var->ertek[i]) {
	if (up_or_low)
	    var->ertek[i] = toupper(var->ertek[i]);
	else
	    var->ertek[i] = tolower(var->ertek[i]);
	i++;
    }
    return;
}
void fv_toupper(struct valtozo *var)
{
    toupper_tolower(var, 1);
    return;
}
void fv_tolower(struct valtozo *var)
{
    toupper_tolower(var, 0);
    return;
}
void fv_strip(struct valtozo *var)
{
    int j, k, i;
    char *s, *p;

    if (parerror(2))
	return;
    j = strlen(numvarlist[1]);
    s = getnumvar(numvarlist, 2, -1);
    free(var->ertek);
    var->ertek = malloc(strlen(s));
    k = 0;
    p = s;
    while (*s) {
	var->ertek[k++] = *s;
	for (i = 0; i < j; i++) {
	    if (toupper(*s) == toupper(numvarlist[1][i])) {
		k--;
		break;
	    }
	}
	s++;
    }
    var->ertek[k] = 0;
    var->ertek = realloc(var->ertek, strlen(var->ertek) + 1);
    free(p);
    return;
}
void fv_split(struct valtozo *var)
{
    int i, j, k;
    char *s, *p, *w;
    char itemp[8], *it;
    struct valtozo *tomb, *elem;
    int save_varflag = varflag;

    if (parerror(3))
	return;
    s = numvarlist[2];
    tomb = getvar(&bivarlist, &s, 0, 1);
    if (tomb) {
	errno = ENOTOMB;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[2]);
	return;
    }
    s = numvarlist[2];
    varflag = VFLAG_NORMAL;
    tomb = getvar(&varlist, &s, 1, 1);
    varflag = save_varflag;
    if (tomb->tipus != VAR_NORMAL && tomb->tipus != VAR_STRUCT) {
	errno = ENOTOMB;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[2]);
	return;
    }
    if (tomb->tipus == VAR_STRUCT)
	freevarlist((struct valtozo *) tomb->ertek, 1);
    else {
	if (tomb->ertek[0]) {
	    errno = ENOTOMB;
	    flag = 1;
	    strcpy(errtemp + 600, numvarlist[2]);
	    return;
	}
	free(tomb->ertek);
	tomb->ertek = NULL;
	tomb->tipus = VAR_STRUCT;
    }
    p = s = getnumvar(numvarlist, 3, -1);
    i = 0;
    do {
	w = strchr(s, numvarlist[1][0]);
	if (w)
	    *w = 0;
	sprintf(itemp, "%d", i);
	it = itemp;
	varflag = tomb->flag;
	elem = getvar((struct valtozo **) (&tomb->ertek), &it, 1, 0);
	varflag = save_varflag;
	setvar(elem, s);
	if (w)
	    s = w + 1;
	i++;
    } while (w);
    free(p);
    sprintf(itemp, "%d", i);
    setvar(var, itemp);
    return;
}
void fv_trim(struct valtozo *var)
{
    char *s, *p, *q;

    if (parerror(1))
	return;
    p = s = getnumvar(numvarlist, 1, -1);
    while (*s) {
	if (!isspace(*s))
	    break;
	s++;
    }
    if (!*s) {
	free(p);
	return;
    }
    q = s + strlen(s) - 1;
    while (q >= s) {
	if (!isspace(*q))
	    break;
	*q = 0;
	q--;
    }
    setvar(var, s);
    free(p);
    return;
}
void fv_srandom(struct valtozo *var)
{
    unsigned int seed;

    if (parerror(1))
	return;
    seed = strtol(numvarlist[1], NULL, 10);
    srand(seed);
    setivar(var, seed);
    return;
}
void fv_random(struct valtozo *var)
{
    int limit;
    int random;

    if (parerror(1))
	return;
    limit = strtol(numvarlist[1], NULL, 10);
    random = (int) (((double) limit) * rand() / (RAND_MAX + 1.0));
    setivar(var, random);
    return;
}
void fv_beep(struct valtozo *var)
{
    if (!botmode)
	printf("\007");
    return;
}
void fv_call(struct valtozo *var)
{
    char *s, *q;
    int i = 0;
    struct valtozo *fv;
    struct kif *kif;

    if (parerror(1))
	return;
    s = malloc(strlen(toretlenargs) + 2);
    strcpy(s + 1, toretlenargs);
    q = s + 1;
    *s = 32;
    resetsoroszlop(0);
    readparancs(&q, PARANCS_EGY_NOVALASZ, 1);
    free(s);
    return;
}
void fv_vezer(struct valtozo *var)
{
    char temp[1024], *t = temp;
    struct valtozo *vez = bivarlist;

    while (vez) {
	if (vez->tipus == VAR_VEZER) {
	    sprintf(t, "%s ", vez->nev);
	    t += strlen(t);
	}
	vez = vez->next;
    }
    setvar(var, temp);
    return;
}
void fv_fv(struct valtozo *var)
{
    char temp[2024], *t = temp;
    struct valtozo *fvs = bivarlist;

    while (fvs) {
	if ((fvs->tipus == VAR_FV) || (fvs->tipus == VAR_ALIAS)) {
	    sprintf(t, "%s ", fvs->nev);
	    t += strlen(t);
	}
	fvs = fvs->next;
    }
    setvar(var, temp);
    return;
}
void fv_array(struct valtozo *var)
{
    struct valtozo *tomb, *elem;
    char temp[256], *t = temp;
    int i, j;
    int honnan;
    int save_varflag = varflag;

    if (parerror(3))
	return;
    i = (int) numvarlist[0];
    strcpy(temp, numvarlist[1]);
    varflag = VFLAG_NORMAL;
    tomb = getvar(&varlist, &t, 1, 1);
    varflag = save_varflag;
    elem = tomb->prev;
    while (elem) {
	if (elem->prev)
	    elem = elem->prev;
	else
	    break;
    }
    if (elem)
	if (elem->parent == &bivarlist) {
	    errno = ENOTOMB;
	    flag = 1;
	    strcpy(errtemp + 600, temp);
	    return;
	}
    if (!tomb) {
	errno = ENOTOMB;
	flag = 1;
	strcpy(errtemp + 600, temp);
	return;
    }
    if ((tomb->tipus == VAR_NORMAL) && (!(tomb->ertek[0]))) {
	free(tomb->ertek);
	tomb->ertek = NULL;
	tomb->tipus = VAR_STRUCT;
    }
    else if (tomb->tipus != VAR_STRUCT) {
	errno = ENONSTRUCT;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    honnan = strtol(numvarlist[2], &t, 10);
    if (*t) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[2]);
	return;
    }
    for (j = 3; j <= i; j++) {
	sprintf(temp, "%d", honnan++);
	t = temp;
	varflag = tomb->flag;
	elem = getvar((struct valtozo **) &(tomb->ertek), &t, 1, 0);
	varflag = save_varflag;
	if (elem->tipus == VAR_NORMAL)
	    setvar(elem, numvarlist[j]);
	else {
	    errno = ENOVAR;
	    flag = 1;
	    sprintf(errtemp + 600, "%d", honnan - 1);
	    return;
	}
    }
    return;
}
struct onstr *freeoneon(struct onstr *mit, int send)
{
    int i;
    struct onstr *ret;

    ret = mit->next;
    if (!mit->prev) {
	if (send)
	    onsendlist = mit->next;
	else
	    onlist = mit->next;
    }
    else {
	mit->prev->next = mit->next;
    }
    if (mit->next)
	mit->next->prev = mit->prev;
    if (mit->nev)
	free(mit->nev);
    freepar(mit->par);
    for (i = 0; i < mit->kifek; i++)
	free(mit->regkifek[i]);
    if (mit->regkifek)
	free(mit->regkifek);
    free(mit);
    return (ret);
}
void inactononsend(int send, int act)
{
    struct onstr *mit;
    int i;
    char *p;

    if (parerror(1))
	return;
    mit = (send) ? onsendlist : onlist;
    if (!mit) {
	errno = ENINCSON;
	flag = 1;
	strcpy(errtemp + 600, "(egysincs)");
	return;
    }
    i = (int) numvarlist[0];
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	p = numvarlist[i];
	mit = (send) ? onsendlist : onlist;
	while (mit) {
	    if (mit->nev)
		if (istrcmp(mit->nev, p) == 0) {
		    mit->tiltott = act;
		    break;
		}
	    if (mit->next)
		mit = mit->next;
	    else {
		errno = ENINCSON;
		flag = 1;
		sprintf(errtemp + 600, "%s", p);
		break;
	    }
	}
    }
    return;
}
void fv_inacton(struct valtozo *var)
{
    inactononsend(0, 1);
    return;
}
void fv_inactonsend(struct valtozo *var)
{
    inactononsend(1, 1);
    return;
}
void fv_acton(struct valtozo *var)
{
    inactononsend(0, 0);
    return;
}
void fv_actonsend(struct valtozo *var)
{
    inactononsend(1, 0);
    return;
}
void unononsend(int send)
{
    struct onstr *mit;
    char *p;
    int i;

    if (parerror(1))
	return;
    mit = (send) ? onsendlist : onlist;
    if (!mit) {
	errno = ENINCSON;
	flag = 1;
	strcpy(errtemp + 600, "(egysincs)");
	return;
    }
    i = (int) numvarlist[0];
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	p = numvarlist[i];
	mit = (send) ? onsendlist : onlist;
	while (mit) {
	    if (mit->nev)
		if (istrcmp(mit->nev, p) == 0) {
		    if (mit->justmark) {
			mit->justmark += 1000;
			break;
		    }
		    freeoneon(mit, send);
		    break;
		}
	    if (mit->next)
		mit = mit->next;
	    else {
		errno = ENINCSON;
		flag = 1;
		sprintf(errtemp + 600, "%s", p);
		break;
	    }
	}
    }
    return;
}
void fv_unon(struct valtozo *var)
{
    unononsend(0);
    return;
}
void fv_unonsend(struct valtozo *var)
{
    unononsend(1);
    return;
}
void inacttimer(int act)
{
    struct timerstr *mit = timerlist;
    int i;

    if (parerror(1))
	return;
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	mit = timerlist;
	while (mit) {
	    if (mit->nev) {
		if (istrcmp(mit->nev, numvarlist[i]) == 0) {
		    mit->tiltott = act;
		    break;
		}
	    }
	    if (mit->next)
		mit = mit->next;
	    else {
		errno = ENOTIMER;
		sprintf(errtemp + 600, "%s", numvarlist[i]);
		flag = 1;
		break;
	    }
	}
    }
    return;
}
void fv_inacttimer(struct valtozo *var)
{
    inacttimer(1);
    return;
}
void fv_acttimer(struct valtozo *var)
{
    inacttimer(0);
    return;
}
void fv_untimer(struct valtozo *var)
{
    struct timerstr *mit = timerlist;
    int i;

    if (parerror(1))
	return;
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	mit = timerlist;
	while (mit) {
	    if (mit->nev) {
		if (istrcmp(mit->nev, numvarlist[i]) == 0) {
		    free(mit->nev);
		    freepar(mit->par);
		    if (mit->next)
			mit->next->prev = mit->prev;
		    if (mit->prev)
			mit->prev->next = mit->next;
		    else
			timerlist = mit->next;
		    free(mit);
		    break;
		}
	    }
	    if (mit->next)
		mit = mit->next;
	    else {
		errno = ENOTIMER;
		sprintf(errtemp + 600, "%s", numvarlist[i]);
		flag = 1;
		break;
	    }
	}
    }
    return;
}
void unset(struct valtozo *var, char *w)
{
    struct valtozo *mit, *smit;
    char temp[256], *t = temp;

    strcpy(temp, w);
    smit = varlist;
    mit = getvar(&smit, &t, 0, 1);
    if (!mit) {
	smit = bivarlist;
	t = temp;
	mit = getvar(&smit, &t, 0, 1);
	smit = mit;
	if (smit) {
	    return;		/*belso valtozot nem lehet torolni es kesz! */
	}
    }
    if (!mit) {
	mit = localvars[locallevel];
	t = temp;
	mit = getvar(&mit, &t, 0, 1);
	if (mit) {
	    if (mit->flag & (VFLAG_LOCAL + VFLAG_BELSO))
		return;
	}
    }
    if (!mit) {
	errno = ENOVAR;
	flag = 1;
	strcpy(errtemp + 600, temp);
	return;
    }
    if (mit->tipus == VAR_NORMAL) {
	setvar(var, mit->ertek);
    }
    freevarlist(mit, 0);
    return;
}
void fv_unset(struct valtozo *var)
{
    int i;

    if (parerror(1))
	return;
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	unset(var, numvarlist[i]);
	if (errno)
	    return;
    }
    return;
}
void purgeall(void)
{
    if (!purge_mod) {
	freevarlist(varlist, 1);
	freenumvarlist(&numvarlist);
	freenumvarlist(&chvarlist);
	freeonlist(onlist);
	freeonlist(onsendlist);
	freetimerlist();
	onlist = onsendlist = NULL;
	timerlist = NULL;
    }
    else if (purge_mod == 1) {
	freeonlist(onlist);
	onlist = NULL;
    }
    else if (purge_mod == 2) {
	freeonlist(onsendlist);
	onsendlist = NULL;
    }
    else if (purge_mod == 3) {
	freetimerlist();
	timerlist = NULL;
    }
    else if (purge_mod == 4) {
	freevarlist(varlist, 1);
	freenumvarlist(&numvarlist);
	freenumvarlist(&chvarlist);
    }
    purge_mod = 0;
    return;
}
void load(char *s)
{
    FILE *fp;
    long l, i;
    char *p, *q;

    if (*s == '~') {
	q = malloc(strlen(home) + strlen(s));
	sprintf(q, "%s%s", home, s + 1);
	fp = fopen(q, "r");
	free(q);
    }
    else
	fp = fopen(s, "r");
    if (!fp) {
	errno = ENOFILE;
	flag = 1;
	sprintf(errtemp + 600, "%s", s);
	return;
    }
    fseek(fp, 0, SEEK_END);
    l = ftell(fp);
    fseek(fp, 0, SEEK_SET);
    p = malloc(l + 2);
    p[0] = 32;
    fread(p + 1, 1, l, fp);
    p[l + 1] = 0;
    for (i = 0; p[i]; i++) {
	if (p[i] == 13)
	    p[i] = 10;
    }
    fclose(fp);
    q = p + 1;
    resetsoroszlop(1);
    readparancs(&q, PARANCS_SOR_NOKAPOCS, 1);
    free(p);
    return;
}
void fv_load(struct valtozo *var)
{
    if (parerror(1))
	return;
    load(numvarlist[1]);
    return;
}
int getszin(char **s, int *mod, int *fg, int *bg)
{
    char *p = *s;
    int i, j;

    *mod = 0;
    *fg = 0;
    *bg = 0;
    for (i = 0; i < 3; i++) {
	j = *p - 48;
	if ((j >= 0) && (j < 9)) {
	    if (!i)
		*mod = (j == 8) ? 0 : j;
	    else if (i == 1)
		*fg = (j == 8) ? 37 : 30 + j;
	    else
		*bg = (j == 8) ? 0 : 40 + j;
	}
	else {
	    *s += i;
	    if (i == 1) {
		if (*mod)
		    *fg = 37;
		else
		    *fg = 0;
	    }
	    return (i);
	}
	p++;
    }
    *s = p;
    return (1);
}
void parseszin(char *p, char *temp)
{
    int sl = 0, mod = 0, fg = 0, bg = 0;
    int i = 0;

    while (*p) {
	if (*p == '\\') {
	    sl ^= 1;
	    if (!sl) {
		temp[i++] = '\\';
		temp[i++] = '\\';
	    }
	    p++;
	    continue;
	}
	if ((*p == '^') && (!sl)) {
	    p++;
	    if (getszin(&p, &mod, &fg, &bg)) {
		strcpy(temp + i, szin(fg, bg, mod));
		i += strlen(temp + i);
	    }
	    else
		temp[i++] = *(p - 1);
	    continue;
	}
	if (sl && *p != '^') {
	    temp[i++] = '\\';
	}
	sl = 0;
	temp[i] = *p;
	i++;
	p++;
    }
    if (sl)
	temp[i++] = '\\';
    temp[i] = 0;
    if (szini) {
	strcpy(temp + i, "\033[0m");
	szini = 0;
    }
    return;
}
void fv_winpack(struct valtozo *var)
{
    int i;

    if (!lastwinline)
	return;
    for (i = lastwinline; i > 0; i--) {
	if (winlines[i])
	    if (winlines[i][0] == 0) {
		free(winlines[i]);
		winlines[i] = NULL;
		lastwinline = i;
	    }
	    else {
		lastwinline = i;
		break;
	    }
    }
    if (!i)
	lastwinline = topline = 0;
    else if (topline > lastwinline && winsize) {
	topline = (lastwinline / winsize) * winsize + 1;
	if (topline > lastwinline)
	    topline -= winsize;
	if (topline < 0)
	    topline = 1;
    }
    writewindow();
    return;
}
void fv_winclear(struct valtozo *var)
{
    winclear();
    writewindow();
    writewindowstatus();
    return;
}
void fv_winputs(struct valtozo *var)
{
    char *s;
    char temp[1024];
    int i;

    if (parerror(1))
	return;
    s = numvarlist[1];
    i = strtol(s, &s, 10);
    if (s == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    if (i < 0)
	i = 1;
    if (i > 1999)
	i = 1999;
    s = getnumvar(numvarlist, 2, -1);
    parseszin(s, temp);
    winfress(i, temp);
    free(s);
    return;
}
void fv_winecho(struct valtozo *var)
{
    char *s;
    char temp[1024];

    s = getnumvar(numvarlist, 1, -1);
    parseszin(s, temp);
    winechostr(temp);
    free(s);
    return;
}
void fv_echo(struct valtozo *var)
{
    char *s, *p;
    char temp[1024];
    int sl = 0;
    int fg, bg, mod;
    int i = 0;

    p = s = getnumvar(numvarlist, 1, -1);
    parseszin(s, temp);
    echostr(temp);
    free(s);
    return;
}
void fv_send(struct valtozo *var)
{
    /*   sendline(toretlenargs); */
    char temp[1024];

    strcpy(temp, toretlenargs);
    strcat(temp, "\n");
    netwrite(temp);
    return;
}
void fv_help(struct valtozo *var)
{
    sendline("/help");
    return;
}
void fv_segit(struct valtozo *var)
{
    sendline("/segit");
    return;
}
char *fv_ac(char *p, int kuld)
{
    char temp[300];
    char *s;

    s = getnumvar(numvarlist, 2, 2);
    if (!kuld) {
	if (*s)
	    switch (toupper(*s)) {
		case 'N':
		case 'C':
		case 'F':
		case 'S':
		    sortby_cur = toupper(*s);
	    }
	else
	    sortby_cur = sortby;
    }
    free(s);
    if (!kuld)
	s = getnumvar(numvarlist, 1, 1);
    else
	s = getnumvar(numvarlist, 1, -1);
    if (kuld)
	sprintf(temp, "%s%s", p, s);
    else
	strcpy(temp, p);
    sendline(temp);
    if (kuld) {
	free(s);
	return (NULL);
    }
    else
	return (s);
}

/* innentol van az beiras */
void fv_whois(struct valtozo *var) {
	fv_ac("/whois ", 1);
	return;
}
void fv_csend() {
	fv_ac("/csend ", 1);
	return;
}

void fv_7bit(struct valtozo *var) {
    fv_ac("/hetbit ", 1);
    return;
}
void fv_sevenbit(struct valtozo *var) {
    fv_ac("/sevenbit ", 1);
    return;
}
void fv_hetbit(struct valtozo *var) {
    fv_ac("/hetbit ", 1);
    return;
}
void fv_8bit(struct valtozo *var) {
    fv_ac("/nyolcbit ", 1);
    return;
}
void fv_eightbit(struct valtozo *var) {
    fv_ac("/eightbit ", 1);
    return;
}
void fv_nyolcbit(struct valtozo *var) {
    fv_ac("/nyolcbit ", 1);
    return;
}
void fv_user(struct valtozo *var) {
    fv_ac("/user ", 1);
    return;
}
void fv_noquery(struct valtozo *var) {
    fv_ac("/noquery ", 1);
    return;
}
void fv_query(struct valtozo *var) {
    fv_ac("/query ", 1);
    return;
}
void fv_topic(struct valtozo *var) {
    fv_ac("/topic ", 1);
    return;
}
void fv_ghost(struct valtozo *var) {
    fv_ac("/ghost ", 1);
    return;
}
void fv_say(struct valtozo *var) {
    fv_ac("/say ", 1);
    return;
}
void fv_me(struct valtozo *var) {
    fv_ac("/me ", 1);
    return;
}
void fv_memsg(struct valtozo *var) {
    fv_ac("/memsg ", 1);
    return;
}

/* eddig van a beiras */

void fv_msg(struct valtozo *var)
{
    fv_ac("/msg ", 1);
    return;
}
void fv_nev(struct valtozo *var)
{
    fv_ac("/nev ", 1);
    return;
}
void fv_join(struct valtozo *var)
{
    if ((!numvarlist) || (!numvarlist[0]))
	fv_ac("/join @", 1);
    else
	fv_ac("/join ", 1);
    return;
}
void fv_from(struct valtozo *var)
{
    if (parerror(1))
	return;
    fromstr = fv_ac("/ki ", 0);
    if (!strlen(fromstr)) {
	free(fromstr);
	fromstr = malloc(2);
	strcpy(fromstr, "*");
    }
    return;
}
void fv_dir(struct valtozo *var)
{
    netwrite("/ki\n");
    ondir = 1;
}
void fv_ki(struct valtozo *var)
{
    kistr = fv_ac("/ki ", 0);
    if (strlen(kistr) == 0) {
	free(kistr);
	kistr = malloc(2);
	strcpy(kistr, "*");
    }
    return;
}
void fv_at(struct valtozo *var)
{
    if (parerror(1))
	return;
    atstr = fv_ac("/ki", 0);
    if (!strlen(atstr)) {
	free(atstr);
	atstr = malloc(2);
	strcpy(atstr, "*");
    }
    return;
}
void fv_quit(struct valtozo *var)
{
    fv_ac("/quit ", 1);
    return;
}
void listvars(struct valtozo *p, int ident, int egy)
{
    char temp[100];
    char tempus[1024];
    struct aliasstr *ali;
    int x;

    if (!p) {
	temp[ident] = 0;
	for (x = ident; x > 0; x--)
	    temp[x - 1] = 32;
	sprintf(tempus, "%s+++%s %s<nincs>", szin(36, 0, 1), szin(32, 0, 1), temp);
	szini = 0;
	if (usewin)
	    winechostr(tempus);
	else
	    echostr(tempus);
	return;
    }
    while (p) {
	temp[ident] = 0;
	for (x = ident; x > 0; x--)
	    temp[x - 1] = 32;
	if (p->tipus == VAR_NORMAL) {
	    sprintf(tempus, "%s+++ %s%s%s %s=%s %s", szin(36, 0, 1), szin(37, 0, 1), temp, p->nev, szin(0, 0, 0), szin(33, 0, 1), p->ertek);
	    szini = 0;
	    if (usewin)
		winechostr(tempus);
	    else
		echostr(tempus);
	}
	else if (p->tipus == VAR_STRUCT) {
	    sprintf(tempus, "%s+++ %s%s %s>struktura<", szin(36, 0, 1), temp, p->nev, szin(0, 0, 0));
	    szini = 0;
	    if (usewin)
		winechostr(tempus);
	    else
		echostr(tempus);
	    listvars((struct valtozo *) p->ertek, ident + 2, 0);
	    sprintf(tempus, "%s+++ %s%s %s>struktura vege<", szin(36, 0, 1), temp, p->nev, szin(0, 0, 0));
	    szini = 0;
	    if (usewin)
		winechostr(tempus);
	    else
		echostr(tempus);
	}
	else if (p->tipus == VAR_ALIAS) {
	    sprintf(tempus, "%s+++ %s%s%s(%s", szin(36, 0, 1), temp, p->nev, szin(0, 0, 0), szin(37, 0, 1));
	    ali = (struct aliasstr *) (p->ertek);
	    for (x = 0; x < ali->cpnum; x++) {
		strcat(tempus, ali->cps[x]);
		if (x != (ali->cpnum - 1))
		    strcat(tempus, " ");
	    }
	    sprintf(tempus + strlen(tempus), "%s)", szin(0, 0, 0));
	    szini = 0;
	    if (usewin)
		winechostr(tempus);
	    else
		echostr(tempus);
	}
	if (egy)
	    return;
	p = p->next;
    }
    return;
}
void fv_list(struct valtozo *var)
{
    struct valtozo *v;
    static char temp[1024];
    char *s;

    if (usewin && !winsize) {
	winsize = oldwinsize;
	setivar(akii_winsize, winsize);
    }
    if (!numvarlist[0]) {
	if (usewin) {
	    strcpy(winbase, "/LIST eredmenye");
	    winclear();
	    writewindow();
	}
	sprintf(temp, "%s+++%s Definialt valtozok:", szin(36, 0, 1), szin(32, 0, 1));
	szini = 0;
	if (!usewin)
	    echostr(temp);
	else
	    winechostr(temp);
	listvars(varlist, 0, 0);
	sprintf(temp, "%s+++%s Belso Valtozol:", szin(36, 0, 1), szin(32, 0, 1));
	szini = 0;
	if (!usewin)
	    echostr(temp);
	else
	    winechostr(temp);
	sprintf(temp, "%s+++%s A belso valtozokat igy ered el: '/list akii'", szin(36, 0, 1), szin(32, 0, 1));
	szini = 0;
	if (!usewin)
	    echostr(temp);
	else
	    winechostr(temp);
	return;
    }
    s = numvarlist[1];
    if (strcmp(s, ".") == 0)
	v = varlist;
    else
	v = getvar(&varlist, &s, 0, 1);
    if (errno) {
	flag = 1;
	sprintf(errtemp + 600, numvarlist[1]);
	return;
    }
    if (usewin) {
	sprintf(winbase, "/LIST \"%s\" eredmenye", numvarlist[1]);
	winclear();
	writewindow();
    }
    listvars(v, 0, 1);
    return;
}
void listons(struct onstr *on, char *s)
{
    char temp[500];
    int i;

    if (!on) {
	sprintf(temp, "%s%%%%%%%s <nincs>", szin(34, 0, 1), szin(0, 0, 0));
	szini = 0;
	if (usewin)
	    winechostr(temp);
	else
	    echostr(temp);
	return;
    }
    while (on) {
	sprintf(temp, "%s%%%%%%%s %s %s%c%s %d %s%s%s ( %s", szin(34, 0, 1), szin(0, 0, 0), s, szin(37, 0, 1), on->tipus, (on->tiltott) ? szin(0, 0, 0) : szin(35, 0, 1), on->szint, (on->tiltott) ? szin(0, 0, 0) : szin(37, 0, 1), (on->nev) ? on->nev : "<nincs>", szin(0, 0, 0), szin(35, 0, 1));
	for (i = 0; i < on->kifek; i++) {
	    sprintf(temp + strlen(temp), "\"%s\" ", on->regkifek[i]);
	}
	sprintf(temp + strlen(temp), "%s) %s", szin(0, 0, 0), (on->tiltott) ? "/inaktiv/" : "");
	szini = 0;
	if (usewin)
	    winechostr(temp);
	else
	    echostr(temp);
	on = on->next;
    }
    return;
}
void fv_onlist(struct valtozo *var)
{
    char temp[100];

    if (usewin && !winsize) {
	winsize = oldwinsize;
	setivar(akii_winsize, winsize);
    }
    if (usewin) {
	winclear();
	writewindow();
	sprintf(winbase, "/ONLIST eredmenye");
    }
    sprintf(temp, "%s%%%%%%%s ON-ok:", szin(34, 0, 1), szin(0, 0, 0));
    szini = 0;
    if (usewin)
	winechostr(temp);
    else
	echostr(temp);
    listons(onlist, "ON");
    sprintf(temp, "%s%%%%%%%s ONSEND-ek:", szin(34, 0, 1), szin(0, 0, 0));
    szini = 0;
    if (usewin)
	winechostr(temp);
    else
	echostr(temp);
    listons(onsendlist, "ONSEND");
    return;
}
void fv_msglist(struct valtozo *var)
{
    char temp[1024];
    int i;
    struct msgs *x = msgk;

    if (!msgk) {
	elemez("@@@ Nincs nev az msg listan.");
	return;
    }
    strcpy(temp, "@@@ Msg lista: ");
    i = strlen(temp);
    while (x) {
	strcat(temp, x->nev);
	strcat(temp, " ");
	x = x->next;
    }
    elemez(temp);
    return;
}
void msgdel(struct msgs *m)
{
    if (!m->prev) {
	msgk = m->next;
	if (!msgk)
	    rmsg = NULL;
	else
	    msgk->prev = NULL;
    }
    else {
	m->prev->next = m->next;
	if (m->next)
	    m->next->prev = m->prev;
	else
	    rmsg = m->prev;
    }
    free(m);
    return;
}
void fv_msgdel(struct valtozo *var)
{
    struct msgs *m = msgk;
    int i, j;

    if (parerror(1))
	return;
    if (!msgk) {
	errno = ENOMSGNEV;
	strcpy(errtemp + 600, "<egysincs>");
	flag = 1;
	return;
    }
    j = (int) numvarlist[0];
    for (i = 1; i <= j; i++) {
	m = msgk;
	while (m) {
	    if (istrcmp(m->nev, numvarlist[i]) == 0) {
		msgdel(m);
		break;
	    }
	    m = m->next;
	}
	if (!m) {
	    errno = ENOMSGNEV;
	    strcpy(errtemp + 600, numvarlist[i]);
	    flag = 1;
	    return;
	}
    }
    return;
}
void listtimers(struct timerstr *t)
{
    char *s;
    char temp[300];
    time_t i;

    if (!t) {
	sprintf(temp, "%s&&&%s <nincs>", szin(35, 0, 1), szin(0, 0, 0));
	szini = 0;
	if (usewin)
	    winechostr(temp);
	else
	    echostr(temp);
	return;
    }
    while (t) {
	i = t->last;
	s = ctime(&i);
	s[19] = 0;
	sprintf(temp, "%s&&&%s TIMER %c %s%s%s (%s%d%s) /utolso aktivitas: %s%s%s/ %s", szin(35, 0, 1), szin(0, 0, 0), t->tipus, (t->tiltott) ? "" : szin(37, 0, 1), (t->nev) ? t->nev : "<nincs>", (t->tiltott) ? "" : szin(0, 0, 0), (t->tiltott) ? "" : szin(35, 0, 1), t->ido, szin(0, 0, 0), szin(37, 0, 1), s + 11, szin(0, 0, 0), (t->tiltott) ? "/inaktiv/" : "");
	szini = 0;
	if (usewin)
	    winechostr(temp);
	else
	    echostr(temp);
	t = t->next;
    }
    return;
}
void fv_timerlist(struct valtozo *var)
{
    char temp[100];

    if (usewin && !winsize) {
	winsize = oldwinsize;
	setivar(akii_winsize, oldwinsize);
    }
    sprintf(temp, "%s&&&%s TIMER-ek:", szin(35, 0, 1), szin(0, 0, 0));
    szini = 0;
    if (usewin) {
	sprintf(winbase, "/TIMERLIST eredmenye");
	winclear();
	writewindow();
	winechostr(temp);
    }
    else
	echostr(temp);
    listtimers(timerlist);
    return;
}
void fv_delay(struct valtozo *var)
{
    struct timeval to;
    int i;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], NULL, 10);
    if (i < 1)
	return;
    to.tv_sec = i / 1000;
    to.tv_usec = (i % 1000) * 1000;
    fflush(stdout);
    select(0, NULL, NULL, NULL, &to);
    return;
}
void fv_purge(struct valtozo *var)
{
    purge = 1;
    purge_mod = 0;
    if (!numvarlist[0])
	return;
    if (istrcmp(numvarlist[1], "on") == 0)
	purge_mod = 1;
    else if (istrcmp(numvarlist[1], "onsend") == 0)
	purge_mod = 2;
    else if (istrcmp(numvarlist[1], "timer") == 0)
	purge_mod = 3;
    else if (istrcmp(numvarlist[1], "set") == 0)
	purge_mod = 4;
    else {
	errno = EPURGE;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
    }
    return;
}
void fv_rehash(struct valtozo *var)
{
    purge = 2;
    return;
}
void fv_log(struct valtozo *var)
{
    char temp[300];
    time_t ido;

    ido = time(NULL);
    if (logfile && ((int) numvarlist[0] > 0)) {
	errno = ELOGEXIST;
	flag = 1;
	strcpy(errtemp + 600, logfilename);
	return;
    }
    if (logfile) {
	fprintf(logfile, "\n~~~ akII LOG kikapcsolva: %s", ctime(&ido));
	fclose(logfile);
	logfile = NULL;
	sprintf(temp, ">>> LOG kikapcsolva: %s", logfilename);
	elemez(temp);
	return;
    }
    if ((int) numvarlist[0] > 0)
	strcpy(logfilename, numvarlist[1]);
    else if (!*logfilename)
	strcpy(logfilename, "akii.log");
    logfile = fopen(logfilename, "a+");
    if (!logfile) {
	errno = EFILEFAIL;
	flag = 1;
	strcpy(errtemp + 600, logfilename);
	return;
    }
    fprintf(logfile, "\n~~~ akII LOG bekapcsolva: %s\n", ctime(&ido));
    sprintf(temp, ">>> LOG bekapcsolva: %s", logfilename);
    elemez(temp);
    return;
}
void fv_wordof(struct valtozo *var)
{
    int i;
    char *s, *p;

    if (parerror(2))
	return;
    i = strtol(numvarlist[1], NULL, 10);
    if (i < 1)
	return;
    s = getnumvar(numvarlist, 2, -1);
    p = s + (i - 1);
    if (*p < 33)
	return;
    while (p > s) {
	if (*p < 33)
	    break;
	p--;
    }
    if (*p < 33)
	p++;
    i = p - s;
    while ((!isspace(*p)) && (*p))
	p++;
    setnvar(var, s + i, p - s - i);
    return;
}
void fv_worddrop(struct valtozo *var)
{
    int i, j;
    char *s, *p;

    if (parerror(2))
	return;
    i = (int) numvarlist[0];
    s = malloc(1024);
    s[0] = 0;
    p = s;
    for (j = 2; j <= i; j++) {
	if (istrcmp(numvarlist[1], numvarlist[j]) != 0) {
	    strcpy(p, numvarlist[j]);
	    p += strlen(p);
	    *p = 32;
	    *++p = 0;
	}
    }
    setvar(var, s);
    free(s);
    return;
}
void fv_asc(struct valtozo *var)
{
    char ret[4];

    if (parerror(1))
	return;
    sprintf(ret, "%d", numvarlist[1][0]);
    setvar(var, ret);
    return;
}
void fv_chr(struct valtozo *var)
{
    int i;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], NULL, 10);
    setvar(var, " ");
    var->ertek[0] = i;
    return;
}
void fv_verzio(struct valtozo *var)
{
    int i = 0;
    struct valtozo *ver;
    char temp[256];

    if (numvarlist)
	i = (int) numvarlist[0];
    if (!i) {
	ver = getvar2("akii.verzio");
	sprintf(temp, ">>> Ezt hasznalod: %s", ver->ertek);
	elemez(temp);
	if (dbgfp) {
	    sprintf(temp, ">>> Debug bekapcsolva. Kimenet: akii.dbg.list");
	    elemez(temp);
	}
	return;
    }
    sprintf(temp, "/msg %s [ak]-AutoAkverQuestion-\n", numvarlist[1]);
    sendline(temp);
    return;
}
void fv_exist(struct valtozo *var)
{
    FILE *fp;

    if (parerror(1))
	return;
    fp = fopen(numvarlist[1], "r");
    errno = 0;
    if (fp) {
	setvar(var, "1");
	fclose(fp);
    }
    else
	setvar(var, "0");
    return;
}
void fv_openrewrite(struct valtozo *var, int rewrite)
{
    struct filelist *fl, *p;
    char q[20];
    FILE *fp = NULL;
    int i;

    setvar(var, "-1");
    if (parerror(1))
	return;
    if (!rewrite)
	fp = fopen(numvarlist[1], "r+");
    if (!fp)
	fp = fopen(numvarlist[1], "w+");
    if (!fp) {
	errno = ENOFILE;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    fl = malloc(sizeof(struct filelist));

    fl->next = fl->prev = NULL;
    fl->fnev = malloc(strlen(numvarlist[1]) + 1);
    strcpy(fl->fnev, numvarlist[1]);
    fl->fp = fp;
    fl->handler = fileno(fp);
    sprintf(q, "%d", fl->handler);
    setvar(var, q);
    errno = 0;
    if (!flist) {
	flist = fl;
	return;
    }
    p = flist;
    while (p) {
	if (fl->handler == p->handler) {
	    errno = EFILEEXIST;
	    strcpy(errtemp + 600, numvarlist[1]);
	    flag = 1;
	    fclose(fp);
	    free(fl->fnev);
	    free(fl);
	    setvar(var, "-1");
	    return;
	}
	if (fl->handler < p->handler)
	    break;
	if (!p->next) {
	    p->next = fl;
	    fl->prev = p;
	    return;
	}
	p = p->next;
    }
    if (p->prev) {
	p->prev->next = fl;
	fl->prev = p->prev;
	p->prev = fl;
	fl->next = p;
	return;
    }
    flist = fl;
    p->prev = fl;
    fl->next = p;
    return;
}
void fv_rewrite(struct valtozo *var)
{
    fv_openrewrite(var, 1);
    return;
}
void fv_open(struct valtozo *var)
{
    fv_openrewrite(var, 0);
    return;
}
void fv_close(struct valtozo *var)
{
    struct filelist *fl;
    int i;
    char *q;

    if (parerror(1))
	return;
    /*ide kell boven */
    i = strtol(numvarlist[1], &q, 10);
    if (q == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    fl = flist;
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    if (!fl->prev) {
	flist = fl->next;
	if (flist)
	    flist->prev = NULL;
	free(fl->fnev);
	fclose(fl->fp);
	free(fl);
	return;
    }
    fl->prev->next = fl->next;
    if (fl->next)
	fl->next->prev = fl->prev;
    fclose(fl->fp);
    free(fl->fnev);
    free(fl);
    return;
}
void fv_fileend(struct valtozo *var)
{
    struct filelist *fl = flist;
    int i;
    char *q;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], &q, 10);
    if (q == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    fseek(fl->fp, 0, SEEK_END);
    return;
}
void fv_readln(struct valtozo *var)
{
    char temp[1024], *s;
    struct filelist *fl = flist;
    char *p;
    int i;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], &p, 10);
    if (p == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    if (feof(fl->fp)) {
	setvar(var, "<EOF>");
	return;
    }
    temp[0] = 0;
    p = fgets(temp, 1024, fl->fp);
    if (s = strchr(temp, '\n'))
	*s = 0;
    if (!p)
	setvar(var, "<EOF>");
    else
	setvar(var, temp);
    return;
}
void fv_writeln(struct valtozo *var)
{
    struct filelist *fl = flist;
    char *s;
    int i;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], &s, 10);
    if (s == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    s = getnumvar(numvarlist, 2, -1);
    fwrite(s, 1, strlen(s), fl->fp);
    fwrite("\n", 1, 1, fl->fp);
    fflush(fl->fp);
    free(s);
    return;
}
void fv_truncate(struct valtozo *var)
{
    struct filelist *fl = flist;
    long pos;
    char temp[16];
    int i;
    long l;
    char *p;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], &p, 10);
    if (p == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    if ((int) numvarlist[0] >= 2) {
	l = strtol(numvarlist[2], &p, 10);
	if (p == numvarlist[1]) {
	    errno = ENONUM;
	    flag = 1;
	    strcpy(errtemp + 600, numvarlist[1]);
	    return;
	}
    }
    else
	l = ftell(fl->fp);
    sprintf(temp, "%d", ftruncate(fl->handler, l));
    setvar(var, temp);
    return;
}
void fv_filepos(struct valtozo *var)
{
    struct filelist *fl = flist;
    long pos;
    char temp[16];
    int i;
    char *p;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], &p, 10);
    if (p == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    sprintf(temp, "%ld", ftell(fl->fp));
    setvar(var, temp);
    return;
}
void fv_filesize(struct valtozo *var)
{
    struct filelist *fl = flist;
    long pos;
    char temp[16];
    int i;
    char *p;

    if (parerror(1))
	return;
    i = strtol(numvarlist[1], &p, 10);
    if (p == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    pos = ftell(fl->fp);
    fseek(fl->fp, 0, SEEK_END);
    sprintf(temp, "%ld", ftell(fl->fp));
    fseek(fl->fp, pos, SEEK_SET);
    setvar(var, temp);
    return;
}
void fv_seek(struct valtozo *var)
{
    struct filelist *fl = flist;
    long pos;
    char *s;
    int i;

    if (parerror(2))
	return;
    i = strtol(numvarlist[1], &s, 10);
    if (s == numvarlist[1]) {
	errno = ENONUM;
	flag = 1;
	strcpy(errtemp + 600, numvarlist[1]);
	return;
    }
    while (fl) {
	if (fl->handler == i)
	    break;
	fl = fl->next;
    }
    if (!fl) {
	errno = ENOFP;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    pos = strtol(numvarlist[2], &s, 10);
    if (*s) {
	errno = ENONUM;
	strcpy(errtemp + 600, numvarlist[2]);
	flag = 1;
	return;
    }
    fseek(fl->fp, pos, SEEK_SET);
    return;
}
void fv_filelist(struct valtozo *var)
{
    struct filelist *fl = flist;
    char temp[256];

    if (usewin && !winsize) {
	winsize = oldwinsize;
	setivar(akii_winsize, winsize);
    }
    sprintf(temp, "%s###%s Fajlok:", szin(33, 0, 1), szin(0, 0, 0));
    szini = 0;
    if (usewin) {
	sprintf(winbase, "/FILELIST eredmenye");
	winclear();
	writewindow();
	winechostr(temp);
    }
    else
	echostr(temp);
    if (!fl) {
	sprintf(temp, "%s###%s <nincs>", szin(33, 0, 1), szin(0, 0, 0));
	szini = 0;
	if (usewin)
	    winechostr(temp);
	else
	    echostr(temp);
	return;
    }
    while (fl) {
	sprintf(temp, "%s###%s %6d%s %s", szin(33, 0, 1), szin(37, 0, 1), fl->handler, szin(0, 0, 0), fl->fnev);
	szini = 0;
	if (usewin)
	    winechostr(temp);
	else
	    echostr(temp);
	fl = fl->next;
    }
    return;
}
void hatra(struct renlist **rl1, struct valtozo *v)
{
    struct renlist *rl;

    if (!*rl1) {
	*rl1 = rl = malloc(sizeof(struct renlist));

	rl->i = 100000000;
	rl->var = v;
	rl->prev = rl->next = NULL;
	return;
    }
    rl = *rl1;
    while (1) {
	if (!rl->next)
	    break;
	rl = rl->next;
    }
    rl->next = malloc(sizeof(struct renlist));

    rl->next->i = 100000000;
    rl->next->var = v;
    rl->next->prev = rl;
    rl->next->next = NULL;
    return;
}
void beszur(struct renlist **rl1, int i, struct valtozo *v)
{
    struct renlist *rl, *r;

    if (!*rl1) {
	*rl1 = rl = malloc(sizeof(struct renlist));

	rl->i = i;
	rl->var = v;
	rl->prev = rl->next = NULL;
	return;
    }
    rl = *rl1;
    while (rl->i < i) {
	if (!rl->next)
	    break;
	rl = rl->next;
    }
    if (i > rl->i) {
	rl->next = malloc(sizeof(struct renlist));

	rl->next->i = i;
	rl->next->var = v;
	rl->next->prev = rl;
	rl->next->next = NULL;
	return;
    }
    r = malloc(sizeof(struct renlist));

    r->next = rl;
    r->prev = rl->prev;
    r->prev->next = r;
    r->next->prev = r;
    r->i = i;
    r->var = v;
    return;
}
void fv_renumber(struct valtozo *var)
{
    struct renlist *rl = NULL, *r;
    struct valtozo *tomb, *v, *ve;
    char *s, temp[256];
    int i, j;

    if (parerror(2))
	return;
    j = strtol(numvarlist[2], &s, 10);
    if (*s) {
	errno = ENONUM;
	strcpy(errtemp + 600, numvarlist[2]);
	flag = 1;
	return;
    }
    v = varlist;
    s = numvarlist[1];
    tomb = getvar(&v, &s, 0, 1);
    if ((errno) || (tomb->tipus != VAR_STRUCT)) {
	errno = ENONSTRUCT;
	strcpy(errtemp + 600, numvarlist[1]);
	flag = 1;
	return;
    }
    v = (struct valtozo *) tomb->ertek;
    while (v) {
	v->parent = NULL;
	i = strtol(v->nev, &s, 10);
	if (*s)
	    hatra(&rl, v);
	else
	    beszur(&rl, i, v);
	v = v->next;
    }
    if (!rl)
	return;
    r = rl;
    v = r->var;
    tomb->ertek = (char *) v;
    v->prev = v->next = NULL;
    v->parent = (struct valtozo **) &tomb->ertek;
    if (r->i < 100000000) {
	free(v->nev);
	sprintf(temp, "%d", j);
	j++;
	v->nev = malloc(strlen(temp) + 1);
	strcpy(v->nev, temp);
    }
    ve = v;
    v = v->next;
    r = r->next;
    while (r) {
	v = r->var;
	v->prev = ve;
	ve->next = v;
	v->next = NULL;
	if (r->i < 100000000) {
	    free(v->nev);
	    sprintf(temp, "%d", j);
	    j++;
	    v->nev = malloc(strlen(temp) + 1);
	    strcpy(v->nev, temp);
	}
	ve = v;
	v = v->next;
	r = r->next;
    }
    return;
}
void fv_local(struct valtozo *var)
{
    char *s;
    int i, j = 0;
    struct valtozo *v;
    int save_varflag = varflag;

    if (parerror(1))
	return;
    if (!locallevel) {
	errno = ELOCAL;
	strcpy(errtemp, "LOCAL");
	return;
    }
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	s = numvarlist[i];
	if (!isalpha(*s)) {
	    j = -1;
	    break;
	}
	while (*s) {
	    if ((!isalnum(*s)) && (*s != '_')) {
		j = -1;
		break;
	    }
	    s++;
	}
	if (j == -1)
	    break;
	s = numvarlist[i];
	varflag = VFLAG_LOCAL;
	v = getvar(&localvars[locallevel], &s, 1, 0);
	varflag = save_varflag;
	if (!((v->tipus == VAR_NORMAL) && (v->ertek[0] == 0))) {
	    errno = EVAREXIST;
	    strcpy(errtemp + 600, numvarlist[i]);
	    flag = 1;
	    return;
	}
    }
    if (j == -1) {
	errno = ECSAKBETU;
	strcpy(errtemp + 600, numvarlist[i]);
	flag = 1;
    }
    return;
}
void fv_use(struct valtozo *var)
{
    int i;

    if (parerror(1))
	return;
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	if (!adduse(numvarlist[i])) {
	    errno = EUSED;
	    flag = 1;
	    strcpy(errtemp + 600, numvarlist[i]);
	    return;
	}
    }
    return;
}
void fv_unuse(struct valtozo *var)
{
    int i;

    if (parerror(1))
	return;
    for (i = 1; i <= (int) numvarlist[0]; i++) {
	if (!deluse(numvarlist[i])) {
	    errno = ENOTUSED;
	    flag = 1;
	    strcpy(errtemp + 600, numvarlist[i]);
	    return;
	}
    }
    return;
}
void fv_uselist(struct valtozo *var)
{
    int i;
    char temp[400];

    if (!usenum) {
	elemez("/// USE lista: <nincs>");
	return;
    }
    strcpy(temp, "/// USE lista: ");
    for (i = 0; i < usenum; i++) {
	sprintf(temp + strlen(temp), "%s, ", use_list[i]);
    }
    elemez(temp);
    return;
}
void fv_insert(struct valtozo *var)
{
    int i;
    char *p, *s;

    if (parerror(3))
	return;
    i = strtol(numvarlist[2], &p, 10);
    if (*p) {
	errno = ENONUM;
	strcpy(errtemp + 600, numvarlist[2]);
	flag = 1;
	return;
    }
    if (i < 0)
	i = 0;
    p = getnumvar(numvarlist, 3, -1);
    if (i > strlen(p))
	i = strlen(p);
    s = malloc(strlen(p) + strlen(numvarlist[1]) + 1);
    strncpy(s, p, i);
    strcpy(s + i, numvarlist[1]);
    strcat(s, p + i);
    setvar(var, s);
    free(s);
    free(p);
    return;
}
#ifndef NOCRYPT
void fv_crypt(struct valtozo *var)
{
    if (parerror(2))
	return;
    if (strlen(numvarlist[1]) < 1) {
	errno = EROVID;
	sprintf(errtemp + 600, "\"%s\" (%d)", numvarlist[1], strlen(numvarlist[1]));
	flag = 1;
	return;
    }
    if (strlen(numvarlist[2]) != 2) {
	errno = EKETTO;
	sprintf(errtemp + 600, "\"%s\" (%d)", numvarlist[2], strlen(numvarlist[2]));
	flag = 1;
	return;
    }
    if (numvarlist[2][0] < 46 || numvarlist[2][0] > 122 || numvarlist[2][1] < 46 || numvarlist[2][1] > 122) {
	errno = ESALT;
	strcpy(errtemp + 600, numvarlist[2]);
	flag = 1;
	return;
    }
    setvar(var, (char *) crypt(numvarlist[1], numvarlist[2]));
    return;
}
#endif
void fv_secureread(struct valtozo *var)
{
    int i;
    char save_inp[1200];
    char r_inp[1200] = "";
    char *save_prompt = akii_prompt->ertek;
    char *prompt;
    int save_cursor = cursor;
    int save_inplen = inplen;
    int save_gorg = gorg;
    int kilep = 0;
    fd_set fs;
    struct timeval tv;

    i = (int) numvarlist[0];
    strcpy(save_inp, inp);
    if (i >= 1) {
	prompt = getnumvar(numvarlist, 1, -1);
    }
    else {
	prompt = malloc(1);
	*prompt = 0;
    }
    akii_prompt->ertek = prompt;
    cursor = 1;
    inplen = 0;
    inp[0] = 0;
    curinp[0] = 1;
    gorg = 0;
    while (!kilep) {
	writeinput();
	writestatus();
	writewindowstatus();
	FD_ZERO(&fs);
	tv.tv_sec = 1;
	tv.tv_usec = 0;
	FD_SET(0, &fs);
	fflush(stdout);
	i = select(1, &fs, NULL, NULL, &tv);
	if (!FD_ISSET(0, &fs))
	    continue;
	i = getch();
	switch (i) {
	    case 8:
	    case 127:
		if (inplen) {
		    strcpy(inp, r_inp);
		    backspace();
		    strcpy(r_inp, inp);
		    for (i = 0; inp[i]; i++)
			inp[i] = '*';
/*                                      writeinput(); */
		}
		break;
	    case 21:
		if (cursor <= 1)
		    break;
		strcpy(inp, r_inp);
		ctrl_u();
		strcpy(r_inp, inp);
		for (i = 0; inp[i]; i++)
		    inp[i] = '*';
/*                                writeinput(); */
		break;
	    case 12:
		refresh(1);
		break;
	    case 11:
		if (cursor > inplen)
		    break;
		strcpy(inp, r_inp);
		ctrl_k();
		strcpy(r_inp, inp);
		for (i = 0; inp[i]; i++)
		    inp[i] = '*';
/*                                writeinput(); */
		break;
	    case KEY_INS:
		insertmode ^= 1;
		writestatus();
		writewindowstatus();
		break;
	    case KEY_HOME:
		if (cursor <= 1)
		    break;
		cursor = 1;
/*                                writeinput(); */
		break;
	    case KEY_END:
		if (cursor >= inplen + 1)
		    break;
		cursor = inplen + 1;
/*                                writeinput(); */
		break;
	    case KEY_DEL:
		if (inplen && (inplen >= cursor)) {
		    cursor++;
		    curcur = -1;
		    strcpy(inp, r_inp);
		    backspace();
		    strcpy(r_inp, inp);
		    for (i = 0; inp[i]; i++)
			inp[i] = '*';
/*                                        writeinput(); */
		}
		break;
	    case KEY_RIGHT:
		if (cursor >= inplen + 1)
		    break;
		cursor++;
		/*writeinput(); */
		break;
	    case KEY_LEFT:
		if (cursor <= 1)
		    break;
		cursor--;
		/*writeinput(); */
		break;
	    case 13:
	    case '\n':
		kilep = 1;
		break;
	    default:
		if ((i > 31) && (i < 256)) {
		    if (inplen > 1022) {
			printf("\07");
			break;
		    }
		    strcpy(inp, r_inp);
		    insert(i);
		    strcpy(r_inp, inp);
		    for (i = 0; inp[i]; i++)
			inp[i] = '*';
/*                                        writeinput(); */
		}
	}
    }
    setvar(var, r_inp);
    akii_prompt->ertek = save_prompt;
    cursor = save_cursor;
    strcpy(inp, saveinp);
    free(prompt);
    curinp[0] = 0;
    inplen = save_inplen;
    gorg = save_gorg;
    writeinput();
    fflush(stdout);
    return;
}
void initcommands(void)
{
    newfv("getenv", fv_getenv);
    newfv("left", fv_left);
    newfv("right", fv_right);
    newfv("mid", fv_mid);
    newfv("index", fv_index);
    newfv("rindex", fv_rindex);
    newfv("word", fv_word);
    newfv("time", fv_time);
    newfv("stime", fv_stime);
    newfv("etime", fv_etime);
    newfv("match", fv_match);
    newfv("rmatch", fv_rmatch);
    newfv("toupper", fv_toupper);
    newfv("tolower", fv_tolower);
    newfv("strip", fv_strip);
    newfv("srandom", fv_srandom);
    newfv("random", fv_random);
    newfv("beep", fv_beep);
    newfv("call", fv_call);
    newfv("fv", fv_fv);
    newfv("vezer", fv_vezer);
    newfv("array", fv_array);
    newfv("unset", fv_unset);
    newfv("load", fv_load);
    newfv("echo", fv_echo);
    newfv("unon", fv_unon);
    newfv("unonsend", fv_unonsend);
    newfv("untimer", fv_untimer);
    newfv("msg", fv_msg);
    newfv("join", fv_join);
    newfv("quit", fv_quit);
    newfv("ki", fv_ki);
    newfv("at", fv_at);
    newfv("from", fv_from);
    newfv("nev", fv_nev);
    newfv("send", fv_send);
    newfv("list", fv_list);
    newfv("wordin", fv_wordin);
    newfv("swordin", fv_swordin);
    newfv("onlist", fv_onlist);
    newfv("delay", fv_delay);
    newfv("timerlist", fv_timerlist);
    newfv("purge", fv_purge);
    newfv("rehash", fv_rehash);
    newfv("wordof", fv_wordof);
    newfv("worddrop", fv_worddrop);
    newfv("asc", fv_asc);
    newfv("chr", fv_chr);
    newfv("verzio", fv_verzio);
    newfv("exist", fv_exist);
    newfv("fileend", fv_fileend);
    newfv("open", fv_open);
    newfv("rewrite", fv_rewrite);
    newfv("close", fv_close);
    newfv("readln", fv_readln);
    newfv("writeln", fv_writeln);
    newfv("filelist", fv_filelist);
    newfv("renumber", fv_renumber);
    newfv("filesize", fv_filesize);
    newfv("filepos", fv_filepos);
    newfv("truncate", fv_truncate);
    newfv("seek", fv_seek);
    newfv("local", fv_local);
    newfv("msglist", fv_msglist);
    newfv("msgdel", fv_msgdel);
    newfv("help", fv_help);
    newfv("segit", fv_segit);
    newfv("inacton", fv_inacton);
    newfv("inactonsend", fv_inactonsend);
    newfv("acton", fv_acton);
    newfv("actonsend", fv_actonsend);
    newfv("inacttimer", fv_inacttimer);
    newfv("acttimer", fv_acttimer);
    newfv("log", fv_log);
    newfv("use", fv_use);
    newfv("unuse", fv_unuse);
    newfv("uselist", fv_uselist);
    newfv("dir", fv_dir);
    newfv("split", fv_split);
    newfv("trim", fv_trim);
    newfv("insert", fv_insert);
    newfv("winecho", fv_winecho);
    newfv("winclear", fv_winclear);
    newfv("winputs", fv_winputs);
    newfv("winpack", fv_winpack);
/* innen */
    newfv("7bit", fv_7bit);
    newfv("sevenbit", fv_sevenbit);
    newfv("hetbit", fv_hetbit);
    newfv("8bit", fv_8bit);
    newfv("eightbit", fv_eightbit);
    newfv("nyolcbit", fv_8bit);
    newfv("user", fv_user);
    newfv("query", fv_query);
    newfv("noquery", fv_noquery);
    newfv("topic", fv_topic);
    newfv("ghost", fv_ghost);
    newfv("say", fv_say);
    newfv("me", fv_me);
    newfv("memsg", fv_memsg);
    newfv("whois", fv_whois);
    newfv("csend", fv_csend);
/* idaig */
#ifndef NOCRYPT
    newfv("crypt", fv_crypt);
#endif
    newfv("secureread", fv_secureread);

    srand(time(NULL));
    return;
}
